package com.elab.mq.config;


import com.alibaba.fastjson.JSONObject;
import com.aliyun.openservices.ons.api.*;
import com.elab.core.utils.RandomUtils;
import com.elab.mq.model.MessageModel;
import com.elab.mq.msg.IMsgProducerFacade;
import com.elab.mq.msg.impl.MsgProducerImpl;
import org.junit.Test;

import java.io.IOException;
import java.util.Map;
import java.util.Properties;

//@RunWith(SpringJUnit4ClassRunner.class)
//@ContextConfiguration(classes = RocketMQConfiguration.class)
//@WebAppConfiguration("classpath:application.properties")
//@TestPropertySource("classpath:application.properties")
public class RocketMQConfigurationTest {
    String topic = "T_consumer2";

    @Test
    public void mqProperties() {
        IMsgProducerFacade producerBean = new MsgProducerImpl();
        producerBean.setProperties(getProperties());
        producerBean.start();
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("xxx", "哈哈");
        jsonObject.put("sss", "ggg");
        for (int i = 0; i < 10; i++) {
            String key = RandomUtils.randomString(10);
            MessageModel message = new MessageModel<Map>("T-consumer1", "*", key, jsonObject);
            SendResult send = producerBean.send(message);
            System.out.println("发送消息返回结果 : " + send.toString());
        }
    }

    /**
     * 对于全局顺序消息，建议创建实例个数 >=2。 同时运行多个实例的作用是为了防止工作实例意外退出时，业务中断。 当工作实例退出时，其他实例可以立即接手工作，不会导致业务中断，实际同时工作的只会有一个实例。
     *
     * @throws IOException
     */
    @Test
    public void consumer() throws IOException {
        Properties properties = getProperties();
        properties.put(PropertyKeyConst.GROUP_ID, "GID-producer1");
        Consumer consumer = ONSFactory.createConsumer(properties);
        MessageListener messageListener = new MessageListener() {
            @Override
            public Action consume(Message message, ConsumeContext consumeContext) {
                System.out.println("消费到的消息 : " + message.toString());
                return Action.CommitMessage;
            }
        };

        consumer.subscribe(topic, "*", messageListener);
        consumer.subscribe("T-consumer1", "*", messageListener);

        consumer.start();
        System.out.println("Consumer Started");
        System.in.read();
    }

    public Properties getProperties() {
        Properties properties = new Properties();
        // AccessKey 阿里云身份验证，在阿里云服务器管理控制台创建
        properties.put(PropertyKeyConst.AccessKey, "LTAImNZed054h0YV");
        // SecretKey 阿里云身份验证，在阿里云服务器管理控制台创建
        properties.put(PropertyKeyConst.SecretKey, "8hmhlhiQ2ikmVeLKujwMNWsktFpSzm");
        // 设置 TCP 接入域名，进入控制台的实例管理页面的“获取接入点信息”区域查看
        properties.put(PropertyKeyConst.NAMESRV_ADDR, "http://MQ_INST_1819241776271348_Bak3xjk0.mq-internet-access.mq-internet.aliyuncs.com:80");
        properties.put(PropertyKeyConst.GROUP_ID, "GID-producer1");
        //设置发送超时时间，单位毫秒
        properties.setProperty(PropertyKeyConst.SendMsgTimeoutMillis, "5000");

        properties.put(PropertyKeyConst.OnsChannel, "ALIYUN");
        // 顺序消息消费者失败进行重试前的等待时间(单位毫秒)
        properties.put(PropertyKeyConst.SuspendTimeMillis, "100");
        // 消费失败的重试次数
        properties.put(PropertyKeyConst.MaxReconsumeTimes, "20");
        return properties;
    }
}
